searchNodes=[{"ref":"Lab42.Message.html","title":"Lab42.Message","type":"module","doc":"A container for error messages. Defining some severities. Create results depending on error messages. Convenience functions for adding, filtering and sorting messages."},{"ref":"Lab42.Message.html#add_critical/3","title":"Lab42.Message.add_critical/3","type":"function","doc":"Create a message with severity :critical and add in front of other messages iex(10)&gt; add_critical([], &quot;Just a critical message&quot;, {1, 3}) [%Lab42.Message{message: &quot;Just a critical message&quot;, severity: :critical, location: {1, 3}}]"},{"ref":"Lab42.Message.html#add_debug/3","title":"Lab42.Message.add_debug/3","type":"function","doc":"Create a message with severity :debug and add in front of other messages iex(2)&gt; add_debug([], &quot;Just a debug message&quot;, {1, 3}) [%Lab42.Message{message: &quot;Just a debug message&quot;, severity: :debug, location: {1, 3}}]"},{"ref":"Lab42.Message.html#add_error/3","title":"Lab42.Message.add_error/3","type":"function","doc":"Create a message with severity :error and add in front of other messages iex(8)&gt; add_error([], &quot;Just a error message&quot;, {1, 3}) [%Lab42.Message{message: &quot;Just a error message&quot;, severity: :error, location: {1, 3}}]"},{"ref":"Lab42.Message.html#add_fatal/3","title":"Lab42.Message.add_fatal/3","type":"function","doc":"Create a message with severity :fatal and add in front of other messages iex(12)&gt; add_fatal([], &quot;Just a fatal message&quot;, {1, 3}) [%Lab42.Message{message: &quot;Just a fatal message&quot;, severity: :fatal, location: {1, 3}}]"},{"ref":"Lab42.Message.html#add_info/3","title":"Lab42.Message.add_info/3","type":"function","doc":"Create a message with severity :info and add in front of other messages iex(4)&gt; add_info([], &quot;Just a info message&quot;, {1, 3}) [%Lab42.Message{message: &quot;Just a info message&quot;, severity: :info, location: {1, 3}}]"},{"ref":"Lab42.Message.html#add_warning/3","title":"Lab42.Message.add_warning/3","type":"function","doc":"Create a message with severity :warning and add in front of other messages iex(6)&gt; add_warning([], &quot;Just a warning message&quot;, {1, 3}) [%Lab42.Message{message: &quot;Just a warning message&quot;, severity: :warning, location: {1, 3}}]"},{"ref":"Lab42.Message.html#extract!/1","title":"Lab42.Message.extract!/1","type":"function","doc":"Extract a value from an ok result iex(13)&gt; extract!(result([], 42)) 42 However, extracting from an error result is not possible iex(14)&gt; extract!({:error, 42, []}) ** (FunctionClauseError) no function clause matching in Lab42.Message.extract!/1"},{"ref":"Lab42.Message.html#make_critical/2","title":"Lab42.Message.make_critical/2","type":"function","doc":"Create a message with severity :critical iex(11)&gt; make_critical(&quot;Just a critical message&quot;, {1, 3}) %Lab42.Message{message: &quot;Just a critical message&quot;, severity: :critical, location: {1, 3}}"},{"ref":"Lab42.Message.html#make_debug/2","title":"Lab42.Message.make_debug/2","type":"function","doc":"Create a message with severity :debug iex(3)&gt; make_debug(&quot;Just a debug message&quot;, {1, 3}) %Lab42.Message{message: &quot;Just a debug message&quot;, severity: :debug, location: {1, 3}}"},{"ref":"Lab42.Message.html#make_error/2","title":"Lab42.Message.make_error/2","type":"function","doc":"Create a message with severity :error iex(9)&gt; make_error(&quot;Just a error message&quot;, {1, 3}) %Lab42.Message{message: &quot;Just a error message&quot;, severity: :error, location: {1, 3}}"},{"ref":"Lab42.Message.html#make_fatal/2","title":"Lab42.Message.make_fatal/2","type":"function","doc":"Create a message with severity :fatal iex(13)&gt; make_fatal(&quot;Just a fatal message&quot;, {1, 3}) %Lab42.Message{message: &quot;Just a fatal message&quot;, severity: :fatal, location: {1, 3}}"},{"ref":"Lab42.Message.html#make_info/2","title":"Lab42.Message.make_info/2","type":"function","doc":"Create a message with severity :info iex(5)&gt; make_info(&quot;Just a info message&quot;, {1, 3}) %Lab42.Message{message: &quot;Just a info message&quot;, severity: :info, location: {1, 3}}"},{"ref":"Lab42.Message.html#make_warning/2","title":"Lab42.Message.make_warning/2","type":"function","doc":"Create a message with severity :warning iex(7)&gt; make_warning(&quot;Just a warning message&quot;, {1, 3}) %Lab42.Message{message: &quot;Just a warning message&quot;, severity: :warning, location: {1, 3}}"},{"ref":"Lab42.Message.html#messages/2","title":"Lab42.Message.messages/2","type":"function","doc":"Extract messages from a list of messages into a library agnositic form as triples. As all the add_* functions create a list in reverse order, this function also rereverses the message tuples. iex(15)&gt; messages = ...(15)&gt; [] ...(15)&gt; |&gt; add_error(&quot;error1&quot;, 1) ...(15)&gt; |&gt; add_info(&quot;info2&quot;, 2) ...(15)&gt; |&gt; add_warning(&quot;warning3&quot;, 3) ...(15)&gt; messages(messages) [ {:error, &quot;error1&quot;, 1}, {:warning, &quot;warning3&quot;, 3} ] As you can see only messages with severity of warning and up are returned. One can of course get messages with less severity too: iex(16)&gt; messages = ...(16)&gt; [] ...(16)&gt; |&gt; add_error(&quot;error1&quot;, 1) ...(16)&gt; |&gt; add_info(&quot;info2&quot;, 2) ...(16)&gt; |&gt; add_debug(&quot;debug3&quot;, 3) ...(16)&gt; messages(messages, severity: :info) [ {:error, &quot;error1&quot;, 1}, {:info, &quot;info2&quot;, 2} ] And, eventually, for your convenience, instead of severity: :debug a shorter and more expressive :all can be passed in iex(17)&gt; messages = ...(17)&gt; [] ...(17)&gt; |&gt; add_error(&quot;error1&quot;, 1) ...(17)&gt; |&gt; add_info(&quot;info2&quot;, 2) ...(17)&gt; |&gt; add_debug(&quot;debug3&quot;, 3) ...(17)&gt; messages(messages, :all) [ {:error, &quot;error1&quot;, 1}, {:info, &quot;info2&quot;, 2}, {:debug, &quot;debug3&quot;, 3} ]"},{"ref":"Lab42.Message.html#result/2","title":"Lab42.Message.result/2","type":"function","doc":"Wrap a value and error messages into a result tuple iex(18)&gt; result([], 42) {:ok, 42, []} Messages of severity warning or less still deliver a :ok result iex(19)&gt; messages = [] ...(19)&gt; |&gt; add_debug(&quot;hello&quot;, 1) ...(19)&gt; |&gt; add_info(&quot;hello again&quot;, 2) ...(19)&gt; |&gt; add_warning(&quot;world&quot;, 3) ...(19)&gt; {:ok, &quot;result&quot;, ^messages} = result(messages, &quot;result&quot;) ...(19)&gt; true true"},{"ref":"Lab42.Message.html#severity_value/1","title":"Lab42.Message.severity_value/1","type":"function","doc":"Assigns to each severity a numerical value, where a higher value indicates a higher severity. iex(20)&gt; severity_value(:debug) 0 The function extracts the severity from a message if necessary iex(21)&gt; severity_value(%Lab42.Message{severity: :error}) 3"},{"ref":"Lab42.Message.html#t:location_t/0","title":"Lab42.Message.location_t/0","type":"type","doc":""},{"ref":"Lab42.Message.html#t:message_t/0","title":"Lab42.Message.message_t/0","type":"type","doc":""},{"ref":"Lab42.Message.html#t:message_ts/0","title":"Lab42.Message.message_ts/0","type":"type","doc":""},{"ref":"Lab42.Message.html#t:result_t/0","title":"Lab42.Message.result_t/0","type":"type","doc":""},{"ref":"Lab42.Message.html#t:severity_t/0","title":"Lab42.Message.severity_t/0","type":"type","doc":""},{"ref":"Lab42.Message.html#t:t/0","title":"Lab42.Message.t/0","type":"type","doc":""},{"ref":"Lab42.Message.html#t:ts/0","title":"Lab42.Message.ts/0","type":"type","doc":""}]